#include <iostream>
#include <stdio.h>
#include <unistd.h>

#include "../Pikafish/src/bitboard.h"
#include "../Pikafish/src/position.h"
#include "../Pikafish/src/search.h"
#include "../Pikafish/src/thread.h"
#include "../Pikafish/src/tt.h"
#include "../Pikafish/src/uci.h"

#include "ffi.h"

// https://jineshkj.wordpress.com/2006/12/22/how-to-capture-stdin-stdout-and-stderr-of-child-program/
#define NUM_PIPES 2
#define PARENT_WRITE_PIPE 0
#define PARENT_READ_PIPE 1
#define READ_FD 0
#define WRITE_FD 1
#define PARENT_READ_FD (pipes[PARENT_READ_PIPE][READ_FD])
#define PARENT_WRITE_FD (pipes[PARENT_WRITE_PIPE][WRITE_FD])
#define CHILD_READ_FD (pipes[PARENT_WRITE_PIPE][READ_FD])
#define CHILD_WRITE_FD (pipes[PARENT_READ_PIPE][WRITE_FD])

int engineMain(int, char **);

const char *Bye = "bye\n";
int pipes[NUM_PIPES][2];
char buffer[80];

int pikafish_init()
{
    pipe(pipes[PARENT_READ_PIPE]);
    pipe(pipes[PARENT_WRITE_PIPE]);
    
    return 0;
}

int pikafish_main()
{
    dup2(CHILD_READ_FD, STDIN_FILENO);
    dup2(CHILD_WRITE_FD, STDOUT_FILENO);
    
    int argc = 1;
    char *argv[] = {""};
    int exitCode = engineMain(argc, argv);
    
    std::cout << Bye << std::flush;
    
    return exitCode;
}

ssize_t pikafish_stdin_write(char *data)
{
    return write(PARENT_WRITE_FD, data, strlen(data));
}

char *pikafish_stdout_read()
{
    ssize_t count = read(PARENT_READ_FD, buffer, sizeof(buffer) - 1);
    if (count < 0)
    {
        return NULL;
    }
    
    buffer[count] = 0;
    if (strcmp(buffer, Bye) == 0)
    {
        return NULL;
    }
    
    return buffer;
}
